﻿// В этом beta варианте все работает. При срабатывании датчика время задержки выключения начинает течь заново;
// При выключении подсветки происходит включение; 
// Скетч для ArduinoMega 2560

#define sensorPin A0					// Нога для фоторезистора включается в A0 http://goo.gl/9gupvj;
unsigned int sensorValue = 0;			// Переменная для снятия показаний сенсора освещенности;
boolean night = 0;						// Если 1 - то ночь;
byte OutPins[2][15] = {2,3,4,5,6,7,8,9,10,11,12,13,44,45,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // Массив PWM ног, сюда включаются входы http://goo.gl/ZM3xCw;
										// первая строка массива - номер ноги, вторая - состояние, 0 - выключена, 1 - включена;
int i, brightness;						// Счетчики для зажигания и тушения диодов;
unsigned long timeWhenSwitchedOn;		// Сюда помним время, когда включили ступеньки;
int startStep, stopStep, increment;		// Переменные для работы со ступеньками;
boolean measuringDistance = 0;			// Флаги стостояний включения и выключения;
boolean switchingOnNow = 0, switchingOffNow = 0, switchedON = 0; 
#define PING_BOTTOM_PIN 30				// PWM Выход нижний ультрасоник sr04;
#define trigPin00 31					// сюда присоединяем тригерную ногу первого датчика
#define PING_TOP_PIN 32					// PWM Выход верхний ультрасоник sr04;
#define trigPin01 33					// сюда присоединяем тригерную ногу второго датчика
byte trig, ping;
unsigned int distance=0;				// Дистанция с ультрасоника;
unsigned int duration = 0;				// Для расчета расстояния;
unsigned int a = 0, b = 0;				// Счетчики превышения сенсора над референсным значанием и значением минус гистерезис
boolean distanceFlag = 0;				// Указывает, с верхнего или нижнего ультрасоника поступили данные;
boolean switchFlag = 0;					// Запоминаем, сверху или снизу включать/выключать;
#define SwitchOnBright 255				// Яркость включенных ступенек, НЕ МЕНЯТЬ!!!;

//************************* Все что ниже - определить самостоятельно ************************************************
unsigned int sensorRef = 1000;			// Референсное значение сенсора освещенности, выше которого считается ночь;
#define SwitchOffDelay 15000			// Задержка выключения посветки, милисекунды (здесь 15 секунд) ;
#define NightBright  20					// Яркость подсвеченных ступенек в ночном режиме (первая, последняя);
#define bottomDistance 40				// Расстояние в см для срабатывания нижнего ультрасоника
#define topDistance 35					// Расстояние в см для срабатывания верхнего ультрасоника
#define smoothSwitchDelayStep 3			// Скорость нарастания яркости ступеньки мс., чем меньше тем быстрее нарастает;

//*******************************************************************************************************************
enum {									// Основной цикл состоит из оператора switch, перечислены его шаги;
	GET_BRIGHTNESS,
	GET_DISTANCE,
	SWITCH_ON,
	SWITCH_OFF,
	WHAT_TO_DO,
} programmSteps;


void setup() {
	
	pinMode(trigPin00,OUTPUT);
	pinMode(trigPin01,OUTPUT);
	pinMode(PING_BOTTOM_PIN,INPUT);
	pinMode(PING_TOP_PIN,INPUT);
	
	for(i=0; i<16; i++) {				// Пишем для каждой ступеньки, что она выключена;
		OutPins[1][i] = 0;
		delay(10);
	}
	programmSteps = GET_BRIGHTNESS;		// Начинаем с проверки день/ночь,
	distanceFlag = 0;					// и нижнего ультрасоника;
}

//===================================================================================================================
void loop() 
{
	switch (programmSteps) {
	case GET_BRIGHTNESS:				// Проверка день/ночь;
	
		sensorValue = 0, a = 0, b = 0;				
		sensorValue = analogRead(sensorPin);				// Что с датчиком освещенности? 
		
		if (sensorValue > sensorRef)  {						// Если однозначно темнее темного - ночь!
			programmSteps = GET_DISTANCE;
			analogWrite(2,NightBright );
			analogWrite(46,NightBright );
			night = 1;
			break;											// Выходим из этого case;		
		}
		
			for(i = 0; i < 10; i++) {						// Иначе приходится разбираться точнее;
				sensorValue = analogRead(sensorPin);		// Чтение показаний датчика;
				if (sensorValue > sensorRef) a++;			// Увеличиваем а, если темнее референсного значения;
				if (sensorValue > (sensorRef - 25)) b++;	// Увеличиваем b, если темнее чем референсное значение минус допуск на гистерезис;
			}
				
			if ((night == 0) && (a > 9)) {					// Если сейчас режим день и 10 раз значение датчика оказалось выше референсного - ночь;
				analogWrite(2,NightBright );
				analogWrite(46,NightBright );
				night = 1;
			}
				
			if ((night == 1) && (b == 0)) {					// Если сейчас режим ночь, и 10 раз значение датчика оказалось ниже референсного - день;
				analogWrite(2,0);
				analogWrite(46,0);
				night = 0;
			}
															// Куда дальше: ночь - читаем ультрасоники, день - опять проверяем освещение;
		(night) ? programmSteps = GET_DISTANCE : programmSteps = GET_BRIGHTNESS; 
			
		break;
	//===========================================================================================
	case GET_DISTANCE:							// Измерим расстояние;
		if (distanceFlag == 0) 	{				// При каждом входе в проверку выбираем верхний или нижний датчик; 
			trig = trigPin00;
			ping = PING_BOTTOM_PIN;
		}
		else {
			trig = trigPin01;
			ping = PING_TOP_PIN;
		}
		
		//delay(5);								// Без этого - не работает, видимо не успевает; 
	
		  digitalWrite(trig, LOW);
		  delayMicroseconds(2);
		  digitalWrite(trig, HIGH);
		  delayMicroseconds(10);
		  digitalWrite(trig, LOW);
		  duration = pulseIn(ping,HIGH);
		  distance = duration/29/2;
	
		distanceFlag = !distanceFlag;			// Сменили флаг для того, чтобы в следующий раз проверить другой ультрасоник;
		programmSteps = WHAT_TO_DO;				// Идем в "главный мозг" :-)
		
		break;
	//==============================================================================================
	case WHAT_TO_DO:							// Размышляем, как поступить;
												// Если сработал нижний ультрасоник при выключенной лестнице - вклюаем, а также начинаем  отсчет времени вновь, если сработал ультрасоник;
		if ((distance < bottomDistance) && (distanceFlag) &&(!switchingOnNow) ) {switchFlag = distanceFlag; programmSteps = SWITCH_ON;}
												// Если сработал верхний ультрасоник при выключенной лестнице - вклюаем, а также начинаем  отсчет времени вновь, если сработал ультрасоник; 
		else if ((distance < topDistance) && (!distanceFlag)&&(!switchingOnNow) ) {switchFlag = distanceFlag; programmSteps = SWITCH_ON;}	
												// Если включено, время выключения не наступило - проверяем ультрасоники;
		else if (((millis() - timeWhenSwitchedOn) <SwitchOffDelay) && switchedON) { programmSteps = GET_DISTANCE;}
												// Если включено и пора выключать - выключаем;
		else if (((millis() - timeWhenSwitchedOn) >=SwitchOffDelay) && switchedON) {programmSteps = SWITCH_OFF;}
												// Иначе проверяем что там с днем и ночью;
		else {programmSteps = GET_BRIGHTNESS;}
	break;
	
	//==============================================================================================
	case SWITCH_ON:								// Включаем лестницу, в зависимости от сработавшего ультрасоника;
		brightness = 0;							
		
		if (distanceFlag) {						// Определяемся с чего начать включение и куда двигаться;
			startStep = 15;
			stopStep = -1;
			increment = -1;
		}
		else {
			startStep = 0;
			stopStep = 16;
			increment = 1;
		}
		
		//======
												// Включаем лесенку, ультрасоники не проверяем;
		for (i=startStep; i != stopStep; i+=increment) {
			if (OutPins[1][i] == 0) {
				for (brightness = 0; brightness <SwitchOnBright; brightness++) {
					analogWrite (OutPins[0][i], brightness);
					delay(smoothSwitchDelayStep);
				}
			}
		}
				
		for(i=0; i<16; i++) {				// Укажем в массив, что все ступеньки включены;
			OutPins[1][i] = 1;
//			delay(10);
		}
				
		switchedON = 1;						// Установим пару флагов для успешной работы;
		switchingOffNow = 0;
		timeWhenSwitchedOn = millis();		// Запомним, когда включили лесенку;
		
	programmSteps = GET_DISTANCE;			// Начнем читать ультрасоники;
	break;
	
		
	//===========================================================================================
	case SWITCH_OFF:						// Выключаем;
		
		if (!switchingOffNow) {				// При первом входе в выключение установим соотвествующий флаг;
			switchingOffNow = 1;
			brightness = SwitchOnBright;
			
			if (switchFlag) {				// Разберемся с направлением выключения;
				startStep = 15;
				stopStep = -1;
				increment = -1;
				OutPins[1][startStep]=0;
			} 
			else {
				startStep = 0;
				stopStep = 16;
				increment = 1;
				OutPins[1][startStep]=0;
			}
		}
		
		if (startStep != stopStep) {		// Выключаем потихоньку...;
			brightness -= 5;
			
			if (brightness > -1) {
				analogWrite(OutPins[0][startStep], brightness);
			}
			
			if (brightness == 0) {
				startStep  += increment;	
				if (startStep != stopStep) {// Выключили ступеньку:
					OutPins[1][startStep]=0;// укажем об этом массиву;
				}
				brightness = SwitchOnBright;
			}
			
			if (startStep == stopStep  ) {	// Как всет выключили
				switchedON = 0;				// установим флаги и
				switchingOffNow = 0;		// включим первую и последнюю ступеньки;
				analogWrite(OutPins[0][0],NightBright);
				analogWrite(OutPins[0][15], NightBright);
			}
		}
			
	programmSteps = GET_DISTANCE;
	break;
	}
}

